tokcase(INP,          "(N)", "");
tokcase(LPOS,         "(N)", "");
tokcase(PEEK,         "(N)", "");
tokcase(SGN,          "(N)",   R"(
    static inline int B_FuncSGN(BAS_UBYTE n) { return n>0; }
    static inline int B_FuncSGN(BAS_UINT n) { return n>0; }
    static inline int B_FuncSGN(BAS_ULONG n) { return n>0; }
    static inline int B_FuncSGN(BAS_BYTE n) { return n<0 ? -1 : n>0 ? 1 : 0; }
    static inline int B_FuncSGN(BAS_INT n) { return n<0 ? -1 : n>0 ? 1 : 0; }
    static inline int B_FuncSGN(BAS_LNG n) { return n<0 ? -1 : n>0 ? 1 : 0; }
    template<typename T>
    static inline int B_FuncSGN(const T& n) { return n<0 ? -1 : n>0 ? 1 : 0; }
)");
tokcase(LOC,          "(N)", "");
tokcase(LOF,          "(N)", "");
     // string -> numeric functions
tokcase(ASC,          "(S)",    R"(
    BAS_UBYTE B_FuncASC(const std::string& s)
    {
        if(unlikely(s.empty())) B_ERROR(5); // illegal function call
        return (unsigned char) s[0];
    }
)");
tokcase(CVD,          "(S)", "");
tokcase(CVI,          "(S)", "");
tokcase(CVL,          "(S)", "");
tokcase(CVS,          "(S)", "");
tokcase(VAL,          "(S)",  ( std::initializer_list<std::string>{ READ_VAL_Common, R"(
    long double B_FuncVAL(const std::string& s)
    {
        long double result;
        B_ReadGeneric<long double, false>(result, s.c_str());
        return result;
    }
)"} ) );
     // implied -> numeric functions
tokcase(CSRLIN,       "", "");
tokcase(ERL,          "", "");
tokcase(ERR,          "", "");
tokcase(FREEFILE,     "",     ( std::initializer_list<std::string>{ Stream_Common, R"(
    BAS_INT B_FuncFREEFILE()
    {
        if(fdmap.empty()) return 1;
        return fdmap.rbegin()->first + 1;
    }
)" } ) );
tokcase(TIMER,        "",       R"(
}
#include <sys/time.h>
namespace
{
    BAS_SGN B_FuncTIMER()
    {
        B_RerenderTextScreen();

        struct timeval tv;
        gettimeofday(&tv, 0);

        time_t midnight = tv.tv_sec;
        struct tm tm;
        localtime_r(&midnight, &tm);
        tm.tm_sec = 0;
        tm.tm_min = 0;
        tm.tm_hour = 0;
        midnight = std::mktime(&tm);

        float result = (tv.tv_sec - midnight) + tv.tv_usec * 1e-6f;
        //return result;

        /* Artificially add a 18.2 hz precision for QB compatibility */
        const float precision = 65536.0f / 0x1234DD;
        //const float precision = 0.5;

        return std::floor(result / precision) * precision;
    }
)");
     // any -> numeric functions
tokcase(LEN,          "(S) | (V)",  ""); // implemented as inline code
tokcase(FRE,          "(X)", "");
     // var_ref -> numeric
tokcase(VARPTR,       "(V)",   R"(
    template<typename T>
    static inline unsigned long B_FuncVARPTR(const T& t)
        { return reinterpret_cast<unsigned long>(&t); } 
)");
tokcase(VARSEG,       "(V)",   R"(
    template<typename T>
    static inline int B_FuncVARSEG(const T& t)
        { return 0; }
)");
     // other
tokcase(FILEATTR,     "(N,N)", "");
tokcase(POINT,        "(N?,n)", "");
tokcase(RND,          "(N)"
                      "|",     R"(
    BAS_SGN  B_FuncRND(int n = 1)
    {
        // n < 0     : generates a number corresponding that value
        // n > 0 or
        // n omitted : next number in sequence
        // n = 0     : returns last number generated
        if(n > 0)
        {
            // generate new
            B_RandomSeed = (B_RandomSeed * 214013 + 2531011) & 0x00FFFFFF;
        }
        else if(n < 0)
        {
            // reseed for n
            n += (n >> 24);
            B_RandomSeed = n & 0x00FFFFFF;
        }
        return B_RandomSeed / (float)(1 << 24);
    }
)");
tokcase(PLAY,         "(N)", ""); // TODO: param can be ignored
tokcase(POS,          "(X)", ""); // TODO: param can be ignored

tokcase(SCREEN,       "(N,N,N)"
                      "|"
                      "(N,N)", "");
tokcase(PMAP,         "(N,N)", "");
tokcase(qb64NEWIMAGE, "(N,N?,n)", "");

tokcase(INSTR,        "(N,S,S)"
                      "|"
                      "(S,S)",   R"(
    int B_FuncINSTR(int pos, const std::string& haystack, const std::string& needle)
    {
        if(unlikely(pos < 0)) B_ERROR(5);
        std::string::size_type p = haystack.find(needle, pos-1);
        if(p == haystack.npos)
            return needle.empty() && std::size_t(pos) <= haystack.size() ? pos : 0;
        return p+1;
    }
    int B_FuncINSTR(         const std::string& haystack, const std::string& needle)
    {
        return B_FuncINSTR(1, haystack, needle);
    }
)");
tokcase(qb64KEYDOWN,  "(N)", "");

    /* Sound functions */
tokcase(qb64SNDRAWLEN, "", "");
tokcase(qb64SNDRATE,   "", "");
tokcase(qb64SNDOPEN,   "(S?,s)", "");
tokcase(qb64SNDPAUSED, "(N)", "");
tokcase(qb64SNDPLAYING, "(N)", "");
tokcase(qb64SNDCOPY,   "(N)", "");
